/*
Copyright (C) 2011, 2012 Bengt Martensson.

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program. If not, see http://www.gnu.org/licenses/.
 */
package org.harctoolbox.IrpMaster;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.LinkedHashMap;

/**
 * This class is a quick and dirty evaluation of the log file.
 *
 * @author Bengt Martensson
 */
public class EvaluateLog {

    LinkedHashMap<String, Integer>map = new LinkedHashMap<String, Integer>();
    
    public EvaluateLog(String filename) throws FileNotFoundException, IOException {
        BufferedReader in = new BufferedReader(new  FileReader(filename));
        String line;
        for (;;) {
            line = in.readLine();
            if (line == null)
                break;
            String[] s = line.split(":");
            if (s[s.length-1].equals(" failed")) {
                map.put(s[0], map.containsKey(s[0]) ? map.get(s[0]) + 1 : 1);
            }
         }
    }
    
    @Override
    public String toString() {
        int total = 0;
        String result = "";
        for (String protocol : map.keySet()) {
            result += protocol + ": " + map.get(protocol) + "\n";
            total += map.get(protocol);
        }
        return result + "\nTotal: " + total;
    }
    
    
    private static void usage(int exitcode) {
        System.err.println("Usage:\n\tEvaluateLogs <logfile>");
        System.exit(exitcode);
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        if (args.length == 0)
            usage(IrpUtils.exitUsageError);
        EvaluateLog el = null;
        try {
            el = new EvaluateLog(args[0]);
        } catch (IOException ex) {
            System.err.println(ex.getMessage());
        }
        System.out.println(el);
    }
}
